#ifndef COMMON_H_INCLUDED
#define COMMON_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif


#include "pc6001v.h"

////////////////////////////////////////////////////////////////
// ėpvZ֐
////////////////////////////////////////////////////////////////
DWORD CalcCrc32( BYTE *, int );						// CRC32vZ


////////////////////////////////////////////////////////////////
// R[h֐
////////////////////////////////////////////////////////////////
void Euc2Jis( BYTE *, BYTE * );						// EUC  -> JIS
void Sjis2Jis( BYTE *, BYTE * );					// SJIS -> JIS
void Jis2Sjis( BYTE *, BYTE * );					// JIS  -> SJIS
void ConvertCodingSystem( BYTE *, BYTE * );			// R[h`ϊ(SJIS,EUC -> JIS)


////////////////////////////////////////////////////////////////
// SDL֘A֐
////////////////////////////////////////////////////////////////
void PSet( SDL_Surface *, int, int, Uint8 );		// _`
Uint8 PGet( SDL_Surface *, int, int );				// F擾



////////////////////////////////////////////////////////////////
// PNG֐
////////////////////////////////////////////////////////////////
void SavePNG( char *, SDL_Surface * );				// PNG SAVE
SDL_Surface *LoadPNG( char * );						// PNG LOAD



#ifdef __cplusplus
}
#endif

#endif	// COMMON_H_INCLUDED
