#ifndef CONSOLE_H_INCLUDED
#define CONSOLE_H_INCLUDED

#include "pc6001v.h"

// 
#define	FC_BLACK	(0)
#define	FC_DBLUE	(1)
#define	FC_DGREEN	(2)
#define	FC_DCYAN	(3)
#define	FC_DRED		(4)
#define	FC_DMAGENTA	(5)
#define	FC_DYELLOW	(6)
#define	FC_GRAY		(7)
#define	FC_BLUE		(9)
#define	FC_GREEN	(10)
#define	FC_CYAN		(11)
#define	FC_RED		(12)
#define	FC_MAGENTA	(13)
#define	FC_YELLOW	(14)
#define	FC_WHITE	(15)



////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cBDF {
protected:
	static SDL_Surface *ZFont;	// ѥեȥǡեؤΥݥ
	static SDL_Surface *HFont;	// ȾѥեȥǡեؤΥݥ
	
	static int zWidth,zHeight;	// ʸ,⤵
	static int hWidth,hHeight;	// Ⱦʸ,⤵
	
public:
	cBDF();													// 󥹥ȥ饯
	~cBDF();												// ǥȥ饯
	
	static BOOL OpenFont( char *, char * );					// եե򳫤
	static void CloseFont();								// եȤ˴
	
	static int FontWidth(){ return hWidth; }				// եȤ(Ⱦ)
	static int FontHeight(){ return hHeight; }				// եȤι⤵
	
	void PutCharh( SDL_Surface*, int, int, Uint8,  Uint8, Uint8 );	// Ⱦʸ
	void PutCharz( SDL_Surface*, int, int, Uint16, Uint8, Uint8 );	// ʸ

};


class ZCons : public cBDF {
protected:
	SDL_Surface *Surf;			// 󥽡륵եؤΥݥ
	SDL_Rect con;				// ϰ
	int Xmax,Ymax;				// Ĳʸ(Ⱦ)
	int x,y;					// 
	Uint8 fgc,bgc;				// 迧طʿ
	
	SDL_Rect pos;				// ɽ֤ȥ
	
	void ScrollUp();			// 륢å
	
public:
	ZCons();									// 󥹥ȥ饯
	virtual ~ZCons();							// ǥȥ饯
	
	SDL_Surface *Create( int, int, char * );	// 󥽡
	void Locate( int, int );					// 
	void LocateR( int, int );					// (кɸ)
	void SetColor( Uint8, Uint8 );				// 迧
	void SetColor( Uint8 );
	void Cls();									// ̾õ
	
	void PutCharH( Uint8 );						// Ⱦ1ʸ
	void PutCharZ( Uint16 );					// 1ʸ
	
	void Print( char *, ... );					// ʸ(ʸб)
	void Printf( char *, ... );					// ʸ(ʸб)
	void Printfr( char *, ... );				// ʸ(ͤ)
	
	int Width() { return Surf ? Surf->w : 0; }	// 󥽡
	int Height(){ return Surf ? Surf->h : 0; }	// 󥽡ι⤵
	
	int GetXline(){ return Xmax; }				// ʸ
	int GetYline(){ return Ymax; }				// ĺʸ
	
	
	void SetPos( int x, int y ){ pos.x = x; pos.y = y; }	// ɽ
	SDL_Rect *GetPos(){ return &pos; }			// ɽּ
	void Show( SDL_Rect * = NULL );				// ꡼ɽ
};


#endif	// CONSOLE_H_INCLUDED
