#ifndef DEBUG_H_INCLUDED
#define DEBUG_H_INCLUDED

#include "pc6001v.h"
#include "console.h"

#include "p6device.h"


#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#define	REGWINW	(40)
#define	REGWINH	( 8)
#define	MEMWINW	(40)
#define	MEMWINH	(15)
#define	MONWINW	(96)
#define	MONWINH	(30)

#define MAX_ARGS	(8)
#define	MAX_CHRS	(256)
#define	PROMPT		"P6V>"

//------------------------------------------------------
//  ץɥ饹
//------------------------------------------------------
class cWndMem : public P6DEVICE, public ZCons {
private:
	WORD Addr;							// ɽɥ쥹
	
public:
	cWndMem( VM6 * );					// 󥹥ȥ饯
	~cWndMem();							// ǥȥ饯
	
	SDL_Surface *Init();				// 
	void Update();						// ɥ
	
	void SetAddress( WORD addr ){ Addr = addr & 0xfff8; }	// ɽɥ쥹
	WORD GetAddress(){ return Addr; }						// ɽɥ쥹
};


//------------------------------------------------------
//  쥸ɥ饹
//------------------------------------------------------
class cWndReg : public P6DEVICE, public ZCons {
private:
	
public:
	cWndReg( VM6 * );					// 󥹥ȥ饯
	~cWndReg();							// ǥȥ饯
	
	SDL_Surface *Init();				// 
	void Update();						// ɥ
};


//------------------------------------------------------
//  ˥ɥ饹
//------------------------------------------------------
class cWndMon : public P6DEVICE, public ZCons {
private:
	char KeyBuf[MAX_CHRS];				// ϥХåե
	char *Argv[MAX_ARGS];				// ؤΥݥ
	int Argc;							// θĿ
	int ArgvCounter;					// Shift()ѥ
	
	struct{								// 
		int Type;	// μ		ARGV_xxx
		int Val;	// 			ARG_xxx ޤϡ
		char *Str;	// ʸ		Argv[xxx]Ʊ
	} argv;
	
	int GetArg();						// 
	void Shift();						// 󥷥ե
	void Exec( int );					// ޥɼ¹
	void Help( int );					// إɽ
	
public:
	cWndMon( VM6 * );					// 󥹥ȥ饯
	~cWndMon();							// ǥȥ饯
	
	SDL_Surface *Init();				// 
	void Update();						// ɥ
	
	void KeyIn( SDL_Event * );			// Ͻ
};
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#endif	// DEBUG_H_INCLUDED
