// ----------------------------------------------------------------------------
//	M88 - PC-8801 series emulator
//	Copyright (C) cisc 1999.
//  ١ˤߤٹΤǤ
// ----------------------------------------------------------------------------
//	$Id: error.cpp,v 1.6 2002/04/07 05:40:08 cisc Exp $

#include "error.h"
#include "osd.h"

Error::Errno Error::err = Error::NoError;

const char *Error::ErrorText[Error::EndofErrors] =
{
	// NoError
	MSERR_NoError,
	// Unknown
	MSERR_Unknown,
	// MemAllocFailed
	MSERR_MemAllocFailed,
	// RomChange
	MSERR_RomChange,
	// NoRom
	MSERR_NoRom,
	// RomSizeNG
	MSERR_RomSizeNG,
	// RomCrcNG
	MSERR_RomCrcNG,
	// SDLInitFailed
	MSERR_SDLInitFailed,
	// InitFailed
	MSERR_InitFailed,
	// FontFailed
	MSERR_FontFailed,
	// IniDefault
	MSERR_IniDefault,
	// IniReadFailed
	MSERR_IniReadFailed,
	// IniWriteFailed
	MSERR_IniWriteFailed,
	// TapeMountFailed
	MSERR_TapeMountFailed,
	// DiskMountFailed
	MSERR_DiskMountFailed,
	// ExtRomMountFailed
	MSERR_ExtRomMountFailed,
	// DokoReadFailed
	MSERR_DokoReadFailed,
	// DokoWriteFailed
	MSERR_DokoWriteFailed,
	// DokoDiffModel
	MSERR_DokoDiffModel
};

const char *Error::GetErrorText()
{
	return ErrorText[err];
}

void Error::SetError( Errno e )
{
	err = e;
}

Error::Errno Error::GetError( void )
{
	return err;
}
