#ifndef PC6001V_H_INCLUDED
#define PC6001V_H_INCLUDED

#include "SDL/SDL.h"


// ˥⡼ɤλѲ(1ǻ)
#define	USEMONITOR	1


/////////////////////////////////////////////////////////////////////////////
// С
/////////////////////////////////////////////////////////////////////////////
#define	VERSION		"Ver.1.06"


/////////////////////////////////////////////////////////////////////////////
// ץ 
/////////////////////////////////////////////////////////////////////////////
//  60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR
#define	DEFAULT_MODEL			(60)
// ĥRAM 0:ʤ 1:
#define	DEFAULT_EXTRAM			(1)
// ԡȤδֳ(ñ:ms 0̵)
#define	DEFAULT_REPEAT			(65)
// ץ󥰥졼
#define	DEFAULT_SAMPLE_RATE		(44100)
// ɥХåեĹΨ(ĹVSYNC)
#define	SOUND_BUFFER_SIZE		(4)
// ޥ
#define	DEFAULT_MASTERVOL		(50)
// PSG
#define	DEFAULT_PSGVOL			(100)
// 
#define	DEFAULT_VOICEVOL		(100)
// TAPE˥
#define	DEFAULT_TAPEVOL			(20)
// Turbo TAPE Yes:ͭ No:̵
#define	DEFAULT_TURBO			(FALSE)
// FDD³
#define	DEFAULT_FDD				(0)
// ⡼ɣ顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ
#define	DEFAULT_MODE4_COLOR		(1)
// 饤 TRUE: FALSE:ʤ
#define	DEFAULT_SCANLINE		(FALSE)
// 饤 (0-100)%
#define	DEFAULT_SCANLINEBR		(25)
// ե졼졼
#define	DEFAULT_FPS				(60)

// ROM᡼ Ǽǥ쥯ȥ
#define	ROM_DIR					"rom"
// TAPE᡼ Ǽǥ쥯ȥ
#define	TAPE_DIR				"tape"
// DISK᡼ Ǽǥ쥯ȥ
#define	DISK_DIR				"disk"
// ĥROM᡼ Ǽǥ쥯ȥ
#define	EXTROM_DIR				"extrom"
// ʥåץå Ǽǥ쥯ȥ
#define	IMAGE_DIR				"img"
// ե Ǽǥ쥯ȥ
#define	FONT_DIR				"font"
// WAVEե Ǽǥ쥯ȥ
#define	WAVE_DIR				"wave"

// CPUå(Hz)
#define	CPU_CLOCK				(3993600)
// VSYNCȿ
#define	VSYNC_HZ				(60)
// ޳߼ȿ 
#define	DEFAULT_TIMER_HZ		(512)
#define	UTIMER_HZ				(DEFAULT_TIMER_HZ*4)
// CMTܡ졼 
#define	DEFAULT_BAUD			(1200)
// CMT߼ȿ  (1byte -> StartBit:1 + DataBit:8 + StopBit:3 = 12bits Ȥ)
#define	DEFAULT_CMT_HZ			(DEFAULT_BAUD/12)
// PSGå(Hz)
#define	PSG_CLOCK				(CPU_CLOCK/2)

// FPS TRUE:ɽ FALSE:ɽ
//#define	DEFAULT_FPS_CNT			(TRUE)


/////////////////////////////////////////////////////////////////////////////
// Ƽե̾ 
/////////////////////////////////////////////////////////////////////////////
#define	CONF_FILE		"pc6001v.ini"
#define	PRINTER_FILE	"printer.txt"
#define	DOKODEMO_FILE	"dokodemo.dds"
#define	SERIAL_FILE		"serial.txt"
#define	SAVE_FILE		"_csave.p6t"
#define	FONTZ_FILE		"fontz12.png"
#define	FONTH_FILE		"fonth12.png"


/////////////////////////////////////////////////////////////////////////////
// ,
/////////////////////////////////////////////////////////////////////////////
#ifdef WIN32
#include <windows.h>
#else
typedef int BOOL;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef MAX_PATH
#define	MAX_PATH	(260)
#endif


/////////////////////////////////////////////////////////////////////////////
// ѥޥ
/////////////////////////////////////////////////////////////////////////////
#define STATIC_CAST(t, o)	static_cast<t> (o)

#define GETWORD(fp)			((WORD)(((BYTE)fgetc(fp))|((BYTE)fgetc(fp)<<8)))
#define GETDWORD(fp)		((DWORD)(((BYTE)fgetc(fp))|((BYTE)fgetc(fp)<<8)|((BYTE)fgetc(fp)<<16)|((BYTE)fgetc(fp)<<24)))
#define PUTWORD(data,fp)	{ fputc(data&0xff,fp); fputc((data>>8)&0xff,fp); }
#define PUTDWORD(data,fp)	{ fputc(data&0xff,fp); fputc((data>>8)&0xff,fp); fputc((data>>16)&0xff,fp); fputc((data>>24)&0xff,fp); }
#define	COUNTOF(arr)		(int)(sizeof(arr)/sizeof((arr)[0]))

#ifndef ZeroMemory
#define ZeroMemory(d,l)	memset((d), 0, (l))
#endif

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif


/////////////////////////////////////////////////////////////////////////////
// SDL 桼٥
/////////////////////////////////////////////////////////////////////////////
#define SENDEVENT(etype)		{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			SDL_PushEvent( &ev ); }

#define SENDEVENT1(etype,data)	{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			ev.user.code = data;	\
			SDL_PushEvent( &ev ); }

#define SENDEVENT2(etype,d1,d2)	{						\
			SDL_Event ev;								\
			ev.type = etype;							\
			ev.user.code = ((d1)<<16)|((d2)&0xffff);	\
			SDL_PushEvent( &ev ); }

#define SENDEVENTP(etype,pnt)	{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			ev.user.data1 = pnt;	\
			SDL_PushEvent( &ev ); }


#define SDL_DRAWSCREEN	(SDL_USEREVENT)
#define SDL_FPSUPDATE	(SDL_USEREVENT+1)
#define SDL_RESTART		(SDL_USEREVENT+2)

#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define SDL_DEBUGMODEBP	(SDL_USEREVENT+10)
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


/////////////////////////////////////////////////////////////////////////////
// ǥХåط
/////////////////////////////////////////////////////////////////////////////
// 1ˤ
#define KEY_LOG		0	/* ϴط */
#define MEM_LOG		0	/* ط */
#define TAPE_LOG	0	/* TAPEط */
#define P6T2_LOG	0	/* P6T2ط */
#define DISK_LOG	0	/* DISKط */
#define FDC_LOG		0	/* FDCط */
#define D88_LOG		0	/* D88ط */
#define PSG_LOG		0	/* PSGط */
#define INTR_LOG	0	/* ߴط */
#define CPU_LOG		0	/* CPUط */
#define SUB_LOG		0	/* CPUط */
#define PPI_LOG		0	/* 8255ط */
#define SND_LOG		0	/* Soundط */
#define GRP_LOG		0	/* ط */
#define OSD_LOG		0	/* OS¸ط */
#define TIC_LOG		0	/* 塼ط */
#define INI_LOG		0	/* INIط */
#define CON_LOG		0	/* 󥹥ȥ饯ط */
#define IO_LOG		0	/* I/Oط */
#define WIN_LOG		0	/* ɥط */
#define CONST_LOG	0	/* 󥹥ȥ饯ǥȥ饯ط */
#define VOI_LOG		0	/* ط */

#if KEY_LOG || MEM_LOG || TAPE_LOG || P6T2_LOG || DISK_LOG || D88_LOG || FDC_LOG || PSG_LOG || INTR_LOG || CPU_LOG || SUB_LOG || SND_LOG || GRP_LOG || OSD_LOG || TIC_LOG || INI_LOG || CON_LOG || IO_LOG || WIN_LOG || CONST_LOG || VOI_LOG
 #define LOG_ON
#endif

#if defined(LOG_ON)
 #include <stdio.h>
 #define PRINTD(m,s)			{ if( m ){ fprintf( stdout, (s) );							fflush( stdout); } }
 #define PRINTD1(m,s,a)			{ if( m ){ fprintf( stdout, (s), (a) );						fflush( stdout); } }
 #define PRINTD2(m,s,a,b)		{ if( m ){ fprintf( stdout, (s), (a), (b) );				fflush( stdout); } }
 #define PRINTD3(m,s,a,b,c)		{ if( m ){ fprintf( stdout, (s), (a), (b), (c) );			fflush( stdout); } }
 #define PRINTD4(m,s,a,b,c,d)	{ if( m ){ fprintf( stdout, (s), (a), (b), (c), (d) );		fflush( stdout); } }
 #define PRINTD5(m,s,a,b,c,d,e)	{ if( m ){ fprintf( stdout, (s), (a), (b), (c), (d), (e) );	fflush( stdout); } }
#else
 #define PRINTD(m,s)
 #define PRINTD1(m,s,a)
 #define PRINTD2(m,s,a,b)
 #define PRINTD3(m,s,a,b,c)
 #define PRINTD4(m,s,a,b,c,d)
 #define PRINTD5(m,s,a,b,c,d,e)
#endif


/////////////////////////////////////////////////////////////////////////////
// ¸ŪʤΤȤ
/////////////////////////////////////////////////////////////////////////////
// ե뼫ưλ饹
//class cFile {
//private:
//	FILE *fp;
//	
//public:
//	cFile( FILE *f ) : fp( f ){}
//	~cFile(){ if( fp ) fclose( fp ); }
//	operator FILE * () const { return fp; }
//};


#endif	// PC6001V_H_INCLUDED
