#ifndef PD8049_H_INCLUDED
#define PD8049_H_INCLUDED

#include "pc6001v.h"
#include "ini.h"

#include "p6device.h"


// ơ
#define	PD8049_IDLE	(0x00)
#define	PD8049_BIT3	(0x08)
#define	PD8049_BIT5	(0x20)
#define	PD8049_BIT7	(0x80)

// CMTơ
#define	CMTCLOSE	(0)
#define	LOADOPEN	(1)
#define	SAVEOPEN	(2)


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class SUB6 : public P6DEVICE, public IDoko {
private:
	int Status;						// ơ
	int CmtStatus;					// CMTơ
	
public:
	SUB6( VM6 * );					// 󥹥ȥ饯
	~SUB6();						// ǥȥ饯
	
	BOOL Init( void );				// 
	void Reset();					// ꥻå
	
	int GetStatus();				// ơ
	
	// ܡɴϢ
	void ReqKeyIntr( int, BYTE );	// ׵
	
	// CMTϢ
	void ReqCmtIntr( BYTE );		// CMT(LOAD)׵
	int GetCmtStatus();				// CMTơ
	
	// 8255ϴϢؿ
	void Command( BYTE );			// ޥɽ
	void HandShake( BYTE );			// ϥɥ(Out93H)
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// PD8049_H_INCLUDED
