#include "breakpoint.h"


#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
BPoint::BPoint( void )
{
	// ֥졼ݥȽ
	for( int i=0; i<NR_BP; i++ ) BP[i].Type = BP_NONE;
	ReqBreak = FALSE;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
BPoint::~BPoint( void ){}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤ̵ͭå
////////////////////////////////////////////////////////////////
BOOL BPoint::ExistBreakPoint( void )
{
	for( int i=0; i<NR_BP; i++ )
		if( BP[i].Type != BP_NONE ) return TRUE;
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤå
////////////////////////////////////////////////////////////////
BOOL BPoint::CheckBreakPoint( BPtype type, WORD addr, BYTE data, char *str )
{
	for( int i=0; i<NR_BP; i++ ){
		if( BP[i].Type == type && BP[i].Addr == addr ){
			BPNo   = i+1;
			BPAddr = addr;
			BPData = data;
			BPStr  = str;
			return TRUE;
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤξ򥯥ꥢ
////////////////////////////////////////////////////////////////
void BPoint::ClearStatus( void )
{
	BPNo   = BP_NONE;
	BPAddr = 0;
	BPData = 0;
	BPStr  = NULL;
}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤΥפ
////////////////////////////////////////////////////////////////
BPoint::BPtype BPoint::GetType( int num )
{
	return BP[num].Type;
}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤΥɥ쥹
////////////////////////////////////////////////////////////////
WORD BPoint::GetAddr( int num )
{
	return BP[num].Addr;
}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤΥפ
////////////////////////////////////////////////////////////////
void BPoint::SetType( int num, BPtype type )
{
	BP[num].Type = type;
}


////////////////////////////////////////////////////////////////
// ֥졼ݥȤΥɥ쥹
////////////////////////////////////////////////////////////////
void BPoint::SetAddr( int num, WORD addr )
{
	BP[num].Addr = addr;
}


////////////////////////////////////////////////////////////////
// ֥졼׵ᤢ?
////////////////////////////////////////////////////////////////
BOOL BPoint::IsReqBreak( void )
{
	return ReqBreak;
}


////////////////////////////////////////////////////////////////
// ֥졼׵
////////////////////////////////////////////////////////////////
void BPoint::SetBreak( void )
{
	ReqBreak = TRUE;
}


////////////////////////////////////////////////////////////////
// ֥졼׵ᥭ󥻥
////////////////////////////////////////////////////////////////
void BPoint::ResetBreak( void )
{
	ReqBreak = FALSE;
}


#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
