#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <new>

#include "global.h"
#include "error.h"
#include "osd.h"

int cGlobal::P6Model = DEFAULT_MODEL;			//  60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR
int cGlobal::OverClock = 100;					// СåΨ (1-1000)%
char cGlobal::WCaption[] = "";					// ɥץ

BOOL cGlobal::IsINI = FALSE;					// INIեɹߥե饰
char cGlobal::IniPath[PATH_MAX] = CONF_FILE;	// INIեѥ

char cGlobal::RomPath[] = "";					// ROMѥ
BOOL cGlobal::UseExtRam = DEFAULT_EXTRAM;		// ĥRAMȤ TRUE: FALSE:ʤ
char cGlobal::ExtRomPath[] = "";				// ĥROMѥ
char cGlobal::ExtRomFile[] = "";				// ĥROMե̾
BOOL cGlobal::CheckCRC = TRUE;					// CRCå TRUE:ͭ FALSE:̵

int cGlobal::KeyRepeat = DEFAULT_REPEAT;		// ԡ

int cGlobal::SampleRate  = DEFAULT_SAMPLE_RATE;	// ץ󥰥졼
int cGlobal::SoundBuffer = SOUND_BUFFER_SIZE;	// ɥХåեĹΨ
int cGlobal::MasterVol   = DEFAULT_MASTERVOL;	// ޥ

int cGlobal::PsgVol      = DEFAULT_PSGVOL;		// PSG

char cGlobal::WavePath[] = "";					// WAVEѥ
int cGlobal::VoiceVol    = DEFAULT_VOICEVOL;	// 

char cGlobal::TapePath[] = "";					// TAPEѥ
char cGlobal::TapeFile[] = "";					// TAPEեեѥ
int cGlobal::CmtVol = DEFAULT_TAPEVOL;			// TAPE˥
BOOL cGlobal::TurboTAPE = FALSE;				// Turbo TAPEͭե饰

char cGlobal::SaveFile[]  = "";					// TAPE(SAVE)եեѥ

char cGlobal::DiskPath[]  = "";					// DISKѥ
char cGlobal::DiskFile[][PATH_MAX] = { "", "" };	// DISKեեѥ
int cGlobal::FddNum = DEFAULT_FDD;				// FDD³

char cGlobal::ImgPath[]  = "";					// ꡼󥷥åȳǼѥ
int cGlobal::Mode4Color  = DEFAULT_MODE4_COLOR;	// ⡼4顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ
BOOL cGlobal::ScanLine   = DEFAULT_SCANLINE;	// 饤 TRUE: FALSE:ʤ
int cGlobal::ScanLineBr  = DEFAULT_SCANLINEBR;	// 饤 (0-100)%
BOOL cGlobal::FullScreen = FALSE;				// ե륹꡼ TRUE:ե FALSE:ɥ
BOOL cGlobal::StatDisp   = TRUE;				// ơСɽ TRUE:ɽ FALSE:ɽ
int cGlobal::FrameRate   = DEFAULT_FPS;			// ե졼졼

char cGlobal::FontPath[]  = "";					// ꡼󥷥åȳǼѥ
char cGlobal::FontFileZ[] = "";					// ѥեȥեѥ
char cGlobal::FontFileH[] = "";					// Ⱦѥեȥեѥ

char cGlobal::PrinterFile[] = "";				// ץ󥿥եեѥ

char cGlobal::DokoFile[] = DOKODEMO_FILE;		// ɤǤSAVEեեѥ

SDL_Color cGlobal::UserColor[128];				// 桼ꥫ顼ǡ ( R,G,B,0  0-255 )
const SDL_Color cGlobal::STDColor[] = {			// ɸ५顼ǡ ( R,G,B,0  0-255 )
				// ƥ५顼
				{   0,   0,   0, 0 },	// 00:
				{   0,   0, 128, 0 },	// 01:
				{   0, 128,   0, 0 },	// 02:
				{   0, 128, 128, 0 },	// 03:
				{ 128,   0,   0, 0 },	// 04:
				{ 128,   0, 128, 0 },	// 05:
				{ 128, 128,   0, 0 },	// 06:
				{ 128, 128, 128, 0 },	// 07:
				{ 192, 192, 192, 0 },	// 08:
				{   0,   0, 255, 0 },	// 09:
				{   0, 255,   0, 0 },	// 10:
				{   0, 255, 255, 0 },	// 11:
				{ 255,   0,   0, 0 },	// 12:
				{ 255,   0, 255, 0 },	// 13:
				{ 255, 255,   0, 0 },	// 14:
				{ 255, 255, 255, 0 },	// 15:
				
				{  20,  20,  20, 0 },	// 16:   *** Ф˸ ***
				// mode 1
				{ 172, 232, 120, 0 },	// 17:(Set1)
				{  40, 152,  20, 0 },	// 18:
				{ 252, 224, 208, 0 },	// 19:(Set2)
				{ 252, 112,   0, 0 },	// 20:
				// mode 2
				{   0, 128,   0, 0 },	// 21:
				{ 255, 255,   0, 0 },	// 22:
				{   0,   0, 255, 0 },	// 23:
				{ 255,   0,   0, 0 },	// 24:
				{ 255, 255, 255, 0 },	// 25:
				{   0, 255, 255, 0 },	// 26:
				{ 255,   0, 255, 0 },	// 27:ޥ
				{ 255, 112,   0, 0 },	// 28:
				// mode 3
				{  40, 255, 100, 0 },	// 29:
				{ 255, 255,   0, 0 },	// 30:
				{   0,   0, 255, 0 },	// 31:
				{ 255,   0,   0, 0 },	// 32:
				{ 255, 255, 255, 0 },	// 33:
				{   0, 255, 255, 0 },	// 34:
				{ 255,   0, 255, 0 },	// 35:ޥ
				{ 255, 112,   0, 0 },	// 36:
				// mode 4
				{  20,  40,  20, 0 },	// 37:(Set1)
				{  60, 220,  60, 0 },	// 38:
				{  40,  20,  20, 0 },	// 39:(Set2)
				{ 224, 255, 208, 0 },	// 40:
				
				{ 225,  47,  32, 0 },	// 41:ˤ (Set1)
				{ 242, 231,   9, 0 },	// 42:ˤ (Set1)
				{   0,   0,   0, 0 },	// 43:ˤ - (Set1)
				{   0,   0,   0, 0 },	// 44:ˤ - (Set1)
				{ 255,  48,   0, 0 },	// 45:ˤ (Set2)
				{ 120, 220, 255, 0 },	// 46:ˤ (Set2)
				{ 255,  72,  72, 0 },	// 47:ˤ (Set2)
				{  40, 255,  80, 0 },	// 48:ˤ (Set2)
				
				// mk2
				{  20,  20,  20, 0 },	// 49:Ʃ()
				{ 255, 172,   0, 0 },	// 50:
				{   0, 255, 172, 0 },	// 51:
				{ 172, 255,   0, 0 },	// 52:
				{ 172,   0, 255, 0 },	// 53:Ļ
				{ 255,   0, 172, 0 },	// 54:ֻ
				{   0, 172, 255, 0 },	// 55:
				{ 172, 172, 172, 0 },	// 56:
				{  20,  20,  20, 0 },	// 57:
				{ 255,   0,   0, 0 },	// 58:
				{   0, 255,   0, 0 },	// 59:
				{ 255, 255,   0, 0 },	// 60:
				{   0,   0, 255, 0 },	// 61:
				{ 255,   0, 255, 0 },	// 62:ޥ
				{   0, 255, 255, 0 },	// 63:
				{ 255, 255, 255, 0 },	// 64:
				
				// mode 4 ˤ
				{   0,   0,   0, 0 },	// 65:äݤ
				{   0,   0,   0, 0 },	// 66:Ĥäݤ
				{   0,   0,   0, 0 },	// 67:֤äݤ
				{ 255, 255, 255, 0 },	// 68:äݤ
				{ 255, 255, 255, 0 },	// 69:Ĥäݤ
				{ 255, 255, 255, 0 },	// 70:֤äݤ
				{ 120, 220, 255, 0 },	// 71:äݤ
				{ 120, 220, 255, 0 },	// 72:äݤ
				{ 120, 220, 255, 0 },	// 73:֤äݤ
				{ 255,  48, 255, 0 },	// 74:äݤ
				{ 255,  48, 255, 0 },	// 75:äݤ
				{ 255,  48, 255, 0 }	// 76:Ĥäݤ
			};


#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
BOOL cGlobal::MonDisp = FALSE;					// ˥ɥɽ TRUE:ɽ FALSE:ɽ
BOOL cGlobal::TimerIntr = TRUE;					// ޳ߵĥե饰 TRUE: FALSE:Ե
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //



////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cGlobal::cGlobal( void ){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cGlobal::~cGlobal( void ){}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cGlobal::Init( void )
{
	// INIեɹ
	if( !IsINI ){
		cIni *Ini = NULL;
		
		// INIեΥѥ
		sprintf( IniPath, "%s" CONF_FILE, OSD_GetModulePath() );
		
		try{
			// INIե뤬ʤʤǥեȤǺ
			if( !OSD_FileExist( IniPath ) )
				if( !CreateINI() ) throw Error::IniDefault;
			
			// INIե򳫤
			Ini = new cIni();
			if( !Ini->Init( IniPath ) ) throw Error::IniDefault;
		}
		catch( std::bad_alloc ){	// new ˼Ԥ
			Error::SetError( Error::MemAllocFailed );
			return FALSE;
		}
		catch( Error::Errno i ){	// 㳰ȯ
			Error::SetError( i );
			
			if( Ini ) delete Ini;
			return FALSE;
		}
		
		IsINI = TRUE;
		
		char str[PATH_MAX];
		int st;
		
		//  ----------
		// 
		Ini->GetInt( "CONFIG", "Model", &P6Model, DEFAULT_MODEL );
		// ɥץ
		switch( P6Model ){
		case 62: sprintf( WCaption, "PC6001V (PC-6001mk2) "   VERSION ); break;
		case 66: sprintf( WCaption, "PC6001V (PC-6601) "      VERSION ); break;
		case 64: sprintf( WCaption, "PC6001V (PC-6001mk2SR) " VERSION ); break;
		case 68: sprintf( WCaption, "PC6001V (PC-6601SR) "    VERSION ); break;
		default: sprintf( WCaption, "PC6001V (PC-6001) "      VERSION ); break;
		}
		// СåΨ
		Ini->GetInt( "CONFIG", "OverClock", &OverClock, 100 );
		
		// ط ----------
		// ROMѥ
		sprintf( str, "%s" ROM_DIR, OSD_GetModulePath() );		// ǥե
		Ini->GetString( "PATH", "RomPath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( RomPath, str, PATH_MAX );
		// ĥRAMȤ
		Ini->GetTruth( "CONFIG", "ExtRam", &st, DEFAULT_EXTRAM );
		UseExtRam = st ? TRUE : FALSE;
		// ĥROMѥ
		sprintf( str, "%s" EXTROM_DIR, OSD_GetModulePath() );	// ǥե
		Ini->GetString( "PATH", "ExtRomPath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( ExtRomPath, str, PATH_MAX );
		// ĥROMե̾(ư˼ưޥ)
		Ini->GetString( "FILES", "ExtRom", str, "" );
		DELIMITER( str );
		if( OSD_FileExist( str ) ) strncpy( ExtRomFile, str, PATH_MAX );
		// CRCå
		Ini->GetTruth( "CONFIG", "CheckCRC", &st, TRUE );
		CheckCRC = st ? TRUE : FALSE;
		
		// ܡɴط ----------
		// ԡ
		Ini->GetInt( "CONFIG", "KeyRepeat", &KeyRepeat, DEFAULT_REPEAT );
		
		// ɴط ----------
		// ץ󥰥졼
		Ini->GetInt( "CONFIG", "SampleRate", &SampleRate, DEFAULT_SAMPLE_RATE );
		// ɥХåեĹΨ
		Ini->GetInt( "CONFIG", "SoundBuffer", &SoundBuffer, SOUND_BUFFER_SIZE );
		// ޥ
		Ini->GetInt( "CONFIG", "MasterVolume", &MasterVol, DEFAULT_MASTERVOL );
		
		// PSGط ----------
		// PSG
		Ini->GetInt( "CONFIG", "PsgVolume", &PsgVol, DEFAULT_PSGVOL );
		
		// ط ----------
		// WAVEѥ
		sprintf( str, "%s" WAVE_DIR, OSD_GetModulePath() );		// ǥե
		Ini->GetString( "PATH", "WavePath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( WavePath, str, PATH_MAX );
		// 
		Ini->GetInt( "CONFIG", "VoiceVolume", &VoiceVol, DEFAULT_VOICEVOL );
		
		// CMTط ----------
		// TAPEѥ
		sprintf( str, "%s" TAPE_DIR, OSD_GetModulePath() );		// ǥե
		Ini->GetString( "PATH", "TapePath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( TapePath, str, PATH_MAX );
		// TAPE˥
		Ini->GetInt( "CONFIG", "TapeVolume", &CmtVol, DEFAULT_TAPEVOL );
		// Turbo TAPEͭե饰
		Ini->GetTruth( "CONFIG", "TurboTAPE", &TurboTAPE, DEFAULT_TURBO );
		
		// DISKط ----------
		// DISKѥ
		sprintf( str, "%s" DISK_DIR, OSD_GetModulePath() );		// ǥե
		Ini->GetString( "PATH", "DiskPath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( DiskPath, str, PATH_MAX );
		// FDD³
		Ini->GetInt( "CONFIG", "FDD", &FddNum, DEFAULT_FDD );
		if( FddNum > 2 ) FddNum = 2;	// 2ޤ
		
		// ̴ط ----------
		// IMGѥ
		sprintf( str, "%s" IMAGE_DIR, OSD_GetModulePath() );	// ǥե
		Ini->GetString( "PATH", "ImgPath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( ImgPath, str, PATH_MAX );
		// ⡼4顼
		Ini->GetInt( "CONFIG", "Mode4Color", &Mode4Color, DEFAULT_MODE4_COLOR );
		// 饤
		Ini->GetTruth( "CONFIG", "ScanLine", &ScanLine, DEFAULT_SCANLINE );
		// 饤
		Ini->GetInt( "CONFIG", "ScanLineBr", &ScanLineBr, DEFAULT_SCANLINEBR );
		// ե졼졼
		Ini->GetInt( "CONFIG", "FrameRate", &FrameRate, DEFAULT_FPS );
		
		// եȴط ----------
		// FONTѥ
		sprintf( str, "%s" FONT_DIR, OSD_GetModulePath() );		// ǥե
		Ini->GetString( "PATH", "FontPath", str, str );
		DELIMITER( str );
		ADDDELIMITER( str );
		strncpy( FontPath, str, PATH_MAX );
		
		// եط ----------
		// ƥեѥȤư
		// TAPEե̾(ư˼ưޥ)
		Ini->GetString( "FILES", "tape", str, "" );
		DELIMITER( str );
		if( OSD_FileExist( str ) ) strncpy( TapeFile, str, PATH_MAX );
		
		// TAPE(SAVE)ե̾(SAVE˼ưޥ)
		sprintf( str, "%s%s", TapePath, SAVE_FILE );	// ǥե
		Ini->GetString( "FILES", "save", str, str );
		DELIMITER( str );
		strncpy( SaveFile, str, PATH_MAX );
		
		// DISKե̾(ư˼ưޥ)
		Ini->GetString( "FILES", "disk", str, "" );
		DELIMITER( str );
		if( OSD_FileExist( str ) ) strncpy( DiskFile[0], str, PATH_MAX );
		
		// ץ󥿥ե̾
		sprintf( str, "%s" PRINTER_FILE, OSD_GetModulePath() );	// ǥե
		Ini->GetString( "FILES", "printer", str, str );
		DELIMITER( str );
		strncpy( PrinterFile, str, PATH_MAX );
		
		// ѥեȥե̾
		sprintf( str, "%s%s", FontPath, FONTZ_FILE );	// ǥե
		Ini->GetString( "FILES", "fontz", str, str );
		DELIMITER( str );
		strncpy( FontFileZ, str, PATH_MAX );
		
		// Ⱦѥեȥե̾
		sprintf( str, "%s%s", FontPath, FONTH_FILE );	// ǥե
		Ini->GetString( "FILES", "fonth", str, str );
		DELIMITER( str );
		strncpy( FontFileH, str, PATH_MAX );
		
		
		// ѥå ----------
		for( int i=0; i<(int)(sizeof(STDColor)/sizeof(SDL_Color)); i++ ){
			char strin[16];
			sprintf( strin, "COL%03d", i );
			sprintf( str,   "%02X%02X%02X", STDColor[i].r, STDColor[i].g, STDColor[i].b );
			if( Ini->GetString( "COLOR", strin, str, str ) ){
				st = strtol( str, NULL, 16 );
				UserColor[i].r = (st>>16)&0xff;
				UserColor[i].g = (st>> 8)&0xff;
				UserColor[i].b = (st    )&0xff;
			}
		}
		
		// INIեĤ
		delete Ini;
	}
	
	// ɤǤSAVEե̾
	sprintf( DokoFile, "%s" DOKODEMO_FILE, OSD_GetModulePath() );	// ǥե
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// INIե뿷
////////////////////////////////////////////////////////////////
BOOL cGlobal::CreateINI( void )
{
	cIni *Ini = NULL;
	FILE *fp;
	try{
		fp = fopen( IniPath, "wt" );
		if( !fp ) throw Error::IniWriteFailed;
		// ȥԤϤưöĤ
		fprintf( fp, MSINI_TITLE );
		fclose( fp );
		
		// INIե򳫤
		Ini = new cIni();
		if( !Ini->Init( IniPath ) ) throw Error::IniDefault;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		
		switch(i){
		case Error::IniWriteFailed:	// INIեν񤭹ߤ˼Ԥ
			return FALSE;
			
		case Error::IniDefault:		// INIեν˼Ԥ
		default:				// 
			delete Ini;
		}
		return FALSE;
	}
	
	// INI֥Ƚ
	InitIni( Ini, TRUE );
	
	// INIե˽
	Ini->Write();
	
	delete Ini;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// INI֥Ƚ
// over TRUE: FALSE:Ρɤ¸ߤƤѥ
////////////////////////////////////////////////////////////////
void cGlobal::InitIni( cIni *Ini, BOOL over )
{
	if( !Ini ) return;
	
	char str[PATH_MAX];
	
	// [CONFIG]
	// 
	if( over || !Ini->GetString( "CONFIG", "Model", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_Model,		"Model",		"%02d",	DEFAULT_MODEL );
	
	// MODE4顼
	if( over || !Ini->GetString( "CONFIG", "Mode4Color", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_Mode4Color,	"Mode4Color",	"%d",	DEFAULT_MODE4_COLOR );
	
	// ץ󥰥졼
	if( over || !Ini->GetString( "CONFIG", "SampleRate", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_SampleRate,	"SampleRate",	"%d",	DEFAULT_SAMPLE_RATE );
	
	// ɥХåեĹΨ
	if( over || !Ini->GetString( "CONFIG", "SoundBuffer", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_SoundBuffer,	"SoundBuffer",	"%d",	SOUND_BUFFER_SIZE );
	
	// FDD
	if( over || !Ini->GetString( "CONFIG", "FDD", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_FDD,			"FDD",			"%d",	DEFAULT_FDD );
	
	// ĥRAM
	if( over || !Ini->GetString( "CONFIG", "ExtRam", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_ExtRam,		"ExtRam",		"%s",	DEFAULT_EXTRAM ? "Yes" : "No" );
	
	// ԡ
	if( over || !Ini->GetString( "CONFIG", "KeyRepeat", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_KeyRepeat,	"KeyRepeat",	"%d",	DEFAULT_REPEAT );
	
	// 饤
	if( over || !Ini->GetString( "CONFIG", "ScanLine", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_ScanLine,	"ScanLine",		"%s",	DEFAULT_SCANLINE ? "Yes" : "No" );
	
	// 饤
	if( over || !Ini->GetString( "CONFIG", "ScanLineBr", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_ScanLineBr,	"ScanLineBr",	"%d",	DEFAULT_SCANLINEBR );
	
	// Turbo TAPE
	if( over || !Ini->GetString( "CONFIG", "TurboTAPE", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_TurboTAPE,	"TurboTAPE",	"%s",	DEFAULT_TURBO ? "Yes" : "No" );
	
	// ե졼졼
	if( over || !Ini->GetString( "CONFIG", "FrameRate", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_FrameRate,	"FrameRate",	"%d",	DEFAULT_FPS );
	
	// ޥ
	if( over || !Ini->GetString( "CONFIG", "MasterVolume", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_MasterVolume,	"MasterVolume",	"%d",	DEFAULT_MASTERVOL );
	
	// PSG
	if( over || !Ini->GetString( "CONFIG", "PsgVolume", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_PsgVolume,	"PsgVolume",	"%d",	DEFAULT_PSGVOL );
	
	// 
	if( over || !Ini->GetString( "CONFIG", "VoiceVolume", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_VoiceVolume,	"VoiceVolume",	"%d",	DEFAULT_VOICEVOL );
	
	// TAPE˥
	if( over || !Ini->GetString( "CONFIG", "TapeVolume", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_TapeVolume,	"TapeVolume",	"%d",	DEFAULT_TAPEVOL );
	
	// СåΨ
	if( over || !Ini->GetString( "CONFIG", "OverClock", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_OverClock,	"OverClock",	"%d",	100 );
	
	// CRCå
	if( over || !Ini->GetString( "CONFIG", "CheckCRC", str, str ) )
		Ini->PutEntry( "CONFIG", MSINI_CheckCRC,	"CheckCRC",		"%s",	"Yes" );
	
	
	//[FILES]
	// ĥROMե̾(ư˼ưޥ)
	if( over || !Ini->GetString( "FILES", "ExtRom", str, str ) )
		Ini->PutEntry( "FILES",	MSINI_ExtRom,	"ExtRom",	"" );
	
	// TAPEե̾(ư˼ưޥ)
	if( over || !Ini->GetString( "FILES", "tape", str, str ) )
		Ini->PutEntry( "FILES", MSINI_tape,		"tape",		"" );
	
	// TAPE(SAVE)ե̾(SAVE˼ưޥ)
	if( over || !Ini->GetString( "FILES", "save", str, str ) ){
		sprintf( str, "%s%s/%s", OSD_GetModulePath(), TAPE_DIR, SAVE_FILE );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES",	MSINI_save,		"save",		str );
	}
	
	// DISKե̾(ư˼ưޥ)
	if( over || !Ini->GetString( "FILES", "disk", str, str ) )
		Ini->PutEntry( "FILES",	MSINI_disk,		"disk",		"" );
	
	// ץ󥿥ե̾
	if( over || !Ini->GetString( "FILES", "printer", str, str ) ){
		sprintf( str, "%s" PRINTER_FILE, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES",	MSINI_printer,	"printer",	str );
	}
	
	// ѥեȥե̾
	if( over || !Ini->GetString( "FILES", "fontz", str, str ) ){
		sprintf( str, "%s%s/%s", OSD_GetModulePath(), FONT_DIR, FONTZ_FILE );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES",	MSINI_fontz,	"fontz",	str );
	}
	
	// Ⱦѥեȥե̾
	if( over || !Ini->GetString( "FILES", "fonth", str, str ) ){
		sprintf( str, "%s%s/%s", OSD_GetModulePath(), FONT_DIR, FONTH_FILE );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES",	MSINI_fonth,	"fonth",	str );
	}
	
	// [PATH]
	// ROMѥ
	if( over || !Ini->GetString( "PATH", "RomPath", str, str ) ){
		sprintf( str, "%s" ROM_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_RomPath,	"RomPath",	str );
	}
	
	// TAPEѥ
	if( over || !Ini->GetString( "PATH", "TapePath", str, str ) ){
		sprintf( str, "%s" TAPE_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_TapePath,	"TapePath",	str );
	}
	
	// DISKѥ
	if( over || !Ini->GetString( "PATH", "DiskPath", str, str ) ){
		sprintf( str, "%s" DISK_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_DiskPath,	"DiskPath",	str );
	}
	
	// ĥROMѥ
	if( over || !Ini->GetString( "PATH", "ExtRomPath", str, str ) ){
		sprintf( str, "%s" EXTROM_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_ExtRomPath,	"ExtRomPath",	str );
	}
	
	// WAVEѥ
	if( over || !Ini->GetString( "PATH", "WavePath", str, str ) ){
		sprintf( str, "%s" WAVE_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_WavePath,	"WavePath",	str );
	}
	
	// IMGѥ
	if( over || !Ini->GetString( "PATH", "ImgPath", str, str ) ){
		sprintf( str, "%s" IMAGE_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_ImgPath,	"ImgPath",	str );
	}
	
	// FONTѥ
	if( over || !Ini->GetString( "PATH", "FontPath", str, str ) ){
		sprintf( str, "%s" FONT_DIR, OSD_GetModulePath() );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH",	MSINI_FontPath,	"FontPath",	str );
	}
	
	// [COLOR]
	// ѥå
	for( int i=17; i<(int)(sizeof(STDColor)/sizeof(SDL_Color)); i++ ){
		char stren[16];
		sprintf( stren, "COL%03d", i );
		if( over || !Ini->GetString( "COLOR", stren, str, str ) )
			Ini->PutEntry( "COLOR", OSD_ColorName( i-17 ), stren, "%02X%02X%02X", STDColor[i].r, STDColor[i].g, STDColor[i].b );
	}
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cGlobal::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	// 
	Ini->PutEntry( "GLOBAL", NULL, "P6Model",		"%02d",	P6Model );
	Ini->PutEntry( "GLOBAL", NULL, "OverClock",		"%d",	OverClock );
	
	// INIեط
	
	// ط
	Ini->PutEntry( "GLOBAL", NULL, "UseExtRam",		"%s",	UseExtRam ? "Yes" : "No" );
	Ini->PutEntry( "GLOBAL", NULL, "ExtRomFile",	"%s",	ExtRomFile );
	
	// ܡɴط
	
	// ɴط
	
	// PSGط
	
	// ط
	
	// CMTط
	Ini->PutEntry( "GLOBAL", NULL, "TapeFile",		"%s",	TapeFile );
	Ini->PutEntry( "GLOBAL", NULL, "SaveFile",		"%s",	SaveFile );
	
	// DISKط
	Ini->PutEntry( "GLOBAL", NULL, "DiskFile_1",	"%s",	DiskFile[0] );
	Ini->PutEntry( "GLOBAL", NULL, "DiskFile_2",	"%s",	DiskFile[1] );
	Ini->PutEntry( "GLOBAL", NULL, "FddNum",		"%d",	FddNum );
	
	// ̴ط
	Ini->PutEntry( "GLOBAL", NULL, "Mode4Color",	"%d",	Mode4Color );
	
	// եȴط
	
	// ط
//	for( int i=17; i<128; i++ ){
//		char stren[16];
//		sprintf( stren, "UserColor_%03d", i );
//		Ini->PutEntry( "GLOBAL", NULL, stren, "0x%02X%02X%02X", UserColor[i].r, UserColor[i].g, UserColor[i].b );
//	}
	
	// ץ󥿴ط
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cGlobal::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	// 
	Ini->GetInt(    "GLOBAL", "P6Model",	&st,			0 );
	if( st == P6Model )
		P6Model = st;
	else{
		Error::SetError( Error::DokoDiffModel );
		return FALSE;
	}
	Ini->GetInt(    "GLOBAL", "OverClock",	&OverClock,		OverClock );
	
	// INIեط
	
	// ط
	Ini->GetTruth(  "GLOBAL", "UseExtRam",	&UseExtRam, UseExtRam );
	Ini->GetString( "GLOBAL", "ExtRomFile", ExtRomFile, ExtRomFile );
	
	// ܡɴط
	
	// ɴط
	
	// PSGط
	
	// ط
	
	// CMTط
	Ini->GetString( "GLOBAL", "TapeFile", 		TapeFile, 		TapeFile );
	Ini->GetString( "GLOBAL", "SaveFile", 		SaveFile, 		SaveFile );
	
	// DISKط
	Ini->GetString( "GLOBAL", "DiskFile_1", 	DiskFile[0], 	DiskFile[0] );
	Ini->GetString( "GLOBAL", "DiskFile_2", 	DiskFile[1], 	DiskFile[1] );
	Ini->GetInt(    "GLOBAL", "FddNum",			&FddNum,		FddNum );
	
	// ̴ط
	Ini->GetInt(    "GLOBAL", "Mode4Color",		&Mode4Color,	Mode4Color );
	
	// եȴط
	
	// ط
//	for( int i=17; i<128; i++ ){
//		char strin[16], str[16];
//		sprintf( strin, "UserColor_%03d", i );
//		sprintf( str,   "0x%02X%02X%02X", UserColor[i].r, UserColor[i].g, UserColor[i].b );
//		if( Ini->GetString( "GLOBAL", strin, str, str ) ){
//			int st = strtol( str, NULL, 16 );
//			UserColor[i].r = (st>>16)&0xff;
//			UserColor[i].g = (st>> 8)&0xff;
//			UserColor[i].b = (st    )&0xff;
//		}
//	}
	
	// ץ󥿴ط
	
	return TRUE;
}
