#ifndef GLOBAL_H_INCLUDED
#define GLOBAL_H_INCLUDED

#include <limits.h>

#include "pc6001v.h"
#include "ini.h"


// ˥⡼ɻϥե륹꡼󤪤ӥ饤ػ
// ե륹꡼⡼ɻϥơСػ
#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define	DISPMON		(cGlobal::MonDisp)
#define	DISPFULL	(!DISPMON && cGlobal::FullScreen)
#define	DISPSCAN	(!DISPMON && cGlobal::ScanLine)
#define	DISPSTAT	(!DISPFULL && cGlobal::StatDisp)

#else

#define	DISPFULL	(cGlobal::FullScreen)
#define	DISPSCAN	(cGlobal::ScanLine)
#define	DISPSTAT	(cGlobal::StatDisp)

#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cGlobal : public IDoko {
protected:
	// 
	static int P6Model;					//  60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR
	static int OverClock;				// СåΨ (1-1000)%
	static char WCaption[256];			// ɥץ
	
	// INIեط
	static BOOL IsINI;					// INIեɹߥե饰
	static char IniPath[PATH_MAX];		// INIեѥ
	
	// ط
	static char RomPath[PATH_MAX];		// ROMѥ
	static BOOL UseExtRam;				// ĥRAMȤ TRUE: FALSE:ʤ
	static char ExtRomPath[PATH_MAX];	// ĥROMѥ
	static char ExtRomFile[PATH_MAX];	// ĥROMե̾
	static BOOL CheckCRC;				// CRCå TRUE:ͭ FALSE:̵
	
	// ܡɴط
	static int KeyRepeat;				// ԡ
	
	// ɴط
	static int SampleRate;				// ץ󥰥졼
	static int SoundBuffer;				// ɥХåեĹΨ
	static int MasterVol;				// ޥ
	
	// PSGط
	static int PsgVol;					// PSG
	
	// ط
	static char WavePath[PATH_MAX];		// WAVEѥ
	static int VoiceVol;				// 
	
	// CMTط
	static char TapePath[PATH_MAX];		// TAPEѥ
	static char TapeFile[PATH_MAX];		// TAPEեեѥ
	static int CmtVol;					// TAPE˥
	static BOOL TurboTAPE;				// Turbo TAPEͭե饰
	
	static char SaveFile[PATH_MAX];		// TAPE(SAVE)եեѥ
	
	// DISKط
	static char DiskPath[PATH_MAX];		// DISKѥ
	static char DiskFile[2][PATH_MAX];	// DISKեեѥ
	static int FddNum;					// FDD³
	
	// ̴ط
	static char ImgPath[PATH_MAX];		// ꡼󥷥åȳǼѥ
	static int Mode4Color;				// ⡼4顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ
	static BOOL ScanLine;				// 饤 TRUE: FALSE:ʤ
	static int ScanLineBr;				// 饤 (0-100)%
	static BOOL FullScreen;				// ե륹꡼ TRUE:ե FALSE:ɥ
	static BOOL StatDisp;				// ơСɽ TRUE:ɽ FALSE:ɽ
	static int FrameRate;				// ե졼졼
	
	// եȴط
	static char FontPath[PATH_MAX];		// ꡼󥷥åȳǼѥ
	static char FontFileZ[PATH_MAX];	// ѥեȥեѥ
	static char FontFileH[PATH_MAX];	// Ⱦѥեȥեѥ
	
	// ط
	static const SDL_Color STDColor[];	// ɸ५顼ǡ
	static SDL_Color UserColor[128];	// 桼ꥫ顼ǡ
	
	// ץ󥿴ط
	static char PrinterFile[PATH_MAX];	// ץ󥿥եեѥ
	
	// ɤǤSAVEط
	static char DokoFile[PATH_MAX];		// ɤǤSAVEեեѥ
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	static BOOL MonDisp;				// ˥ɥɽ TRUE:ɽ FALSE:ɽ
	static BOOL TimerIntr;				// ޳ߵĥե饰
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	cGlobal();								// 󥹥ȥ饯
	virtual ~cGlobal();						// ǥȥ饯
	
	static BOOL Init();						// 
	static BOOL CreateINI();				// INIե뿷
	static void InitIni( cIni *, BOOL );	// INI֥Ƚ
	static void UnInit(){ IsINI = FALSE; }	// ˴
	
	// Хؿ
	static int  GetModel(){ return P6Model; }						// 
	static void SetModel( int data ){ P6Model = data; }				//     
	
	static char *GetRomPath(){ return RomPath; }					// ROMѥ
	static char *GetTapePath(){ return TapePath; }					// TAPEѥ
	static char *GetDiskPath(){ return DiskPath; }					// DISKѥ
	static char *GetFontPath(){ return FontPath; }					// FONTѥ
	static char *GetFontFileZ(){ return FontFileZ; }				// ѥեȥե̾
	static char *GetFontFileH(){ return FontFileH; }				// Ⱦѥեȥե̾
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// GLOBAL_H_INCLUDED
