#ifndef KEYBOARD_H_INCLUDED
#define KEYBOARD_H_INCLUDED

#include "pc6001v.h"
#include "ini.h"

#include "p6device.h"


// ܡɥ󥸥
#define	KI_KANA		(1)
#define	KI_KKANA	(2)
#define	KI_CAPS		(4)


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class KEY6 : public P6DEVENT, public IDoko {
protected:
	Uint8 *P6KeyTable[SDLK_LAST];	// ơ֥ؤΥݥ
	
	// ü쥭 ե饰
	BOOL ON_SHIFT;	// SHIFT
	BOOL ON_GRAPH;	// GRAPH
	BOOL ON_KANA;	// 
	BOOL ON_KKANA;	// 
	BOOL ON_CTRL;	// CTRL
	BOOL ON_STOP;	// STOP
	BOOL ON_CAPS;	// CAPS
	
	// ưϾ¤
	typedef struct{
		char *Buffer;			// Хåեݥ
		int Num;				// Ĥʸ
		int Wait;				// Ԥ
		BOOL Relay;				// 졼åOFFԤե饰
		int Seek;
	} AKEY;
	AKEY ak;					// ưϾ
	
	char GetAutoKey();					// ư1ʸ
	
public:
	KEY6( VM6 * );						// 󥹥ȥ饯
	virtual ~KEY6();					// ǥȥ饯
	
	void EventCallback( int, int );		// ٥ȥХåؿ
	
	BOOL Init( int );					// 
	
	void ScanKeyboard( SDL_Event * );	// 
	BYTE GetKeyJoy();					// 륭ּ
	BYTE GetKeyIndicator();				// ܡɥ󥸥ּ
	
	BOOL SetAutoKey( char *, int );		// ưʸ
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class KEY60 : public KEY6 {
public:
	KEY60( VM6 * );						// 󥹥ȥ饯
	~KEY60();							// ǥȥ饯
};


#endif	// KEYBOARD_H_INCLUDED
