// OSˑ̔ėp[`(UIp)
// ɍ킹ĕR[hύX邱
//  Windows : ShiftJIS
//  Unix    : EUC

#include <windows.h>
#include <shlobj.h>
#include <string.h>

#include "SDL/SDL_syswm.h"

#include "osd.h"
#include "common.h"
#include "p6v.h"


///////////////////////////////////////////////////////////
// [J֐`
///////////////////////////////////////////////////////////
static BOOL CALLBACK OsdBrowseCallbackProc( HWND, UINT, LPARAM, LPARAM ); // OSD_FolderDiaog()ŎgpR[obNvV[W


///////////////////////////////////////////////////////////
// dȂɃO[oϐ
///////////////////////////////////////////////////////////
static HANDLE hMutex;			// dN`FbNp̃~[ebNX
static BROWSEINFO OBI;			// OSD_FolderDiaog()Ŏgpi[\



////////////////////////////////////////////////////////////////
// ɂ镶r
//
// :	s1			r镶ւ̃|C^1
//			s2			r镶ւ̃|C^2
// Ԓl:	int			0: :s1>s2 :s1<s2
////////////////////////////////////////////////////////////////
int stricmp ( const char *s1, const char *s2 )
{
	const char *ps1 = s1, *ps2 = s2;
	
	if( !s1 ) return -1;
	if( !s2 ) return  1;
	
	// 擪̕
	char c1 = *ps1++;
	char c2 = *ps2++;
	
	// ǂ炩̕I[܂ŌJԂ
	while( c1 && c2 ){
		// ɕϊ
		if( c1 >= 'A' && c1 <= 'Z' ) c1 += 'a' - 'A';
		if( c2 >= 'A' && c2 <= 'Z' ) c2 += 'a' - 'A';
		
		// ȂrI
		if( c1 != c2 ) break;
		
		// ̕擾
		c1 = *ps1++;
		c2 = *ps2++;
	}
	
	return (int)c1 - (int)c2;
}


////////////////////////////////////////////////////////////////
// dN`FbN
//
// :	Ȃ
// Ԓl:	BOOL		TRUE:Nς FALSE:N
////////////////////////////////////////////////////////////////
BOOL OSD_IsWorking( void )
{
	// CEBhENX̖O
	#define	MWCLASS	"p6vmainw"
	
	PRINTD( OSD_LOG, "[OSD][OSD_IsWorking]\n" );
	
	HANDLE hCheckMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, MWCLASS );
	if( hCheckMutex ){
		CloseHandle( hCheckMutex );
		return TRUE;
	}
	hMutex = CreateMutex( FALSE, 0, MWCLASS );
	return FALSE;
}


////////////////////////////////////////////////////////////////
// I
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_Finish( void )
{
	PRINTD( OSD_LOG, "[OSD][OSD_Finish]\n" );
	
	// Mutex J
	ReleaseMutex( hMutex );
}


////////////////////////////////////////////////////////////////
// W[pX擾
//
// :	Ȃ
// Ԓl:	char *		擾ւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetModulePath( void )
{
	PRINTD( OSD_LOG, "[OSD][OSD_GetModulePath]\n" );
	
	static char mpath[PATH_MAX] = "";	// W[pX擾p
	
	char Drive[3];
	char Dir[PATH_MAX];
	
	int num = GetModuleFileName( NULL, mpath, PATH_MAX );
	_splitpath( mpath, Drive, Dir, NULL, NULL );
	sprintf( mpath, "%s%s", Drive, Dir );
	if( num ) DELIMITER( mpath );
	ADDDELIMITER( mpath );	// Ô
	
	return mpath;
}


////////////////////////////////////////////////////////////////
// tpXt@C擾
//
// :	path		tpXi[obt@|C^
// Ԓl:	char *		t@C̊Jn|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetFileNamePart( const char *path )
{
	PRINTD( OSD_LOG, "[OSD][OSD_GetFileNamePart]\n" );
	
	char Drive[3];
	char Dir[PATH_MAX];
	
	_splitpath( path, Drive, Dir, NULL, NULL );
	
	return &path[strlen( Drive ) + strlen( Dir )];
}


////////////////////////////////////////////////////////////////
// t@C̑݃`FbN
//
// :	path		tpXi[obt@|C^
// Ԓl:	BOOL		TRUE:݂ FALSE:݂Ȃ
////////////////////////////////////////////////////////////////
BOOL OSD_FileExist( const char *fullpath )
{
	PRINTD( OSD_LOG, "[OSD][OSD_FileExist]\n" );
	
	char filename[PATH_MAX+1];
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	BOOL ret = FALSE;
	
	strncpy( filename, fullpath, PATH_MAX );
	
	DELDELIMITER( filename );
	UNDELIMITER( filename );
	
	hFind = FindFirstFile( filename, &FindFileData );
	if( hFind != INVALID_HANDLE_VALUE ) ret = TRUE;
	FindClose( hFind );
	
	return ret;
}


///////////////////////////////////////////////////////////
// tH_̎Q
//
// :	hwnd		ẽEBhEnh
//			Result		tH_ւ̃pXi[obt@|C^
// Ԓl:	char *		擾ւ̃|C^
///////////////////////////////////////////////////////////
const char *OSD_FolderDiaog( void *hwnd, char *Result )
{
	LPMALLOC Memory;
	LPITEMIDLIST Ret, Root;
	char Buffer[PATH_MAX];
	
	//VFIMallocC^tF[XɃ|C^擾
	SHGetMalloc( &Memory );
	
	//u}CRs[^vtH_̈ʒu擾
	SHGetSpecialFolderLocation( (HWND)hwnd, CSIDL_DRIVES, &Root );
	
	// tH_̃pX
	UNDELIMITER( Result );
	
	//BrowseInfo\̂̏ݒ
	ZeroMemory( &OBI, sizeof(BROWSEINFO) );
	OBI.hwndOwner = (HWND)hwnd;			// eEChẼnh
	OBI.pidlRoot  = Root;				// [gtH_(CSIDL_~~)
	OBI.ulFlags   = BIF_STATUSTEXT | BIF_RETURNONLYFSDIRS;	// tH_̃^CvtO(BIF_~~)
	OBI.lpszTitle = "tH_IĂB";			// ^Cgij
	OBI.pszDisplayName = Buffer;		// (߂l)tH_
	OBI.lpfn = OsdBrowseCallbackProc;	// R[obN֐̃Gg|Cg
	OBI.lParam = (LPARAM)Result;		// R[obN֐ɓn
    	
	//utH_̎QƁv_CAO\
	Ret = SHBrowseForFolder( &OBI );
	
	if( SHGetPathFromIDList( Ret, Buffer ) ){
		//̉
		Memory->Free( Ret );
		Memory->Free( Root );
		
		lstrcpyn( Result, Buffer, PATH_MAX-1 );
		DELDELIMITER( Result );
		UNDELIMITER( Result );
		return Result;
	}else{
		//̉
		Memory->Free( Ret );
		Memory->Free( Root );
		
		return NULL;
	}
}

// OSD_FolderDiaog()ŎgpR[obNvV[W
static BOOL CALLBACK OsdBrowseCallbackProc( HWND hwnd, UINT msg, LPARAM lp1, LPARAM lp2 )
{
	char Path[PATH_MAX*2];	// Ô2{?
	
	// BIF_STATUSTEXTȊO͉Ȃ
	if( OBI.ulFlags & BIF_STATUSTEXT ){
		switch( msg ){
		case BFFM_INITIALIZED:	// 
			// tH_ݒ
			SendMessage( hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lp2 );
			break;
		case BFFM_SELCHANGED:	// [U[tH_ύX
			// ITEMIDLIST\̂pXo
			SHGetPathFromIDList( (LPCITEMIDLIST)lp1, Path );
			// ύXꂽtH_̃pX\
			SendMessage( hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)Path );
		}
	}
	return FALSE;
}


///////////////////////////////////////////////////////////
// t@C̎Q
//
// :	hwnd		ẽEBhEnh
//			mode		[h FM_Load:t@CJ FM_Save:Otĕۑ
//			title		EBhELvVւ̃|C^
//			filter		t@CtB^ւ̃|C^
//			fullpath	tpXi[obt@|C^
//			path		t@CpXi[obt@|C^
//			ext			gqւ̃|C^
// Ԓl:	char *		擾t@Cւ̃|C^(tpXł͂Ȃ)
///////////////////////////////////////////////////////////
const char *OSD_FileDiaog( void *hwnd, FileMode mode, const char *title, const char *filter, char *fullpath, char *path, const char *ext )
{
	OPENFILENAME fname;
	char File[PATH_MAX] = "";
	char Path[PATH_MAX] = "";
	BOOL ret = FALSE;
	
	if( !fullpath ) return NULL;
	
	if( OSD_FileExist( fullpath ) ){
		strncpy( File, fullpath, PATH_MAX );
		UNDELIMITER( File );
	}else if( path ){
		strncpy( Path, path,     PATH_MAX );
		UNDELIMITER( Path );
	}
	
	ZeroMemory( &fname, sizeof(OPENFILENAME) );
	
	fname.lStructSize     = sizeof(OPENFILENAME);
	fname.hwndOwner       = (HWND)hwnd;		// ẽEBhEnh
	fname.lpstrFilter     = filter;			// t@CtB^
	fname.nFilterIndex    = 1;				// 1Ԗڂ̃t@CtB^g
	fname.lpstrFile       = File;			// IꂽtpX̊i[
	fname.nMaxFile        = sizeof(File);	// ̃TCY
	fname.lpstrInitialDir = Path;			// tH_
	fname.lpstrTitle      = title;			// ^Cg
	fname.lpstrDefExt     = ext;			// gqȗĂꍇɒǉgq
//	fname.Flags           = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
	
	if( mode == FM_Save ){
		fname.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetSaveFileName( &fname );
	}else{
		fname.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetOpenFileName( &fname );
	}
	
	if( ret ){
		DELIMITER( File )
		// pXۑ
		if( path ) strncpy( path, File, fname.nFileOffset );
		// tpXۑ
		if( fullpath ) strncpy( fullpath, File, PATH_MAX );
		// t@Cւ̃|C^Ԃ
		return fullpath + fname.nFileOffset;
	}else
		return NULL;
}


////////////////////////////////////////////////////////////////
// et@CI
//
// :	hwnd		ẽEBhEnh(NULL̏ꍇ̓XN[T[tFX̃nh擾݂)
//			type		_CAO̎(FileDlgQ)
//			fullpath	tpXi[obt@|C^
//			path		t@CpXi[obt@|C^
// Ԓl:	char *		擾t@Cւ̃|C^(tpXł͂Ȃ)
////////////////////////////////////////////////////////////////
const char *OSD_FileSelect( void *hwnd, FileDlg type, char *fullpath, char *path )
{
	HWND shwnd    = (HWND)hwnd;
	FileMode mode = FM_Load;
	char *title   = NULL;
	char *filter  = NULL;
	char *ext     = NULL;
	
	switch( type ){
	case FD_TapeLoad:	// TAPE(LOAD)I
		mode   = FM_Load;
		title  = "TAPE(LOAD)J";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case FD_TapeSave:	// TAPE(SAVE)I
		mode   = FM_Save;
		title  = "TAPE(SAVE)J";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case FD_Disk:		// DISKI
		mode   = FM_Load;
		title  = "DISKJ";
		filter = "DISKC[W\0*.d88\0"
				 "D88` (*.d88)\0*.d88\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "d88";
		break;
		
	case FD_ExtRom:		// gROMI
		mode   = FM_Load;
		title  = "gROMC[WI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
		
	case FD_Printer:	// v^[o̓t@CI
		mode   = FM_Save;
		title  = "v^[o̓t@CI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		ext    = "txt";
		break;
		
	case FD_FontZ:		// SptHgt@CI
		mode   = FM_Load;
		title  = "SptHgt@CI";
		filter = "PNGt@C (*.png)\0*.png\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "png";
		break;
		
	case FD_FontH:		// ptHgt@CI
		mode   = FM_Load;
		title  = "ptHgt@CI";
		filter = "PNGt@C (*.png)\0*.png\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "png";
		break;
		
	case FD_DokoLoad:	// ǂłLOADt@CI
		mode   = FM_Load;
		title  = "ǂłLOADt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	case FD_DokoSave:	// ǂłSAVEt@CI
		mode   = FM_Save;
		title  = "ǂłSAVEt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	default:		// ėp
		mode   = FM_Load;
		title  = "t@CJ";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
	}
	
	// EBhEnh NULL ,XN[T[tFX̃nh擾݂
	if( !hwnd ){
		SDL_SysWMinfo WinInfo;
		SDL_VERSION( &WinInfo.version );
		shwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	}
	
	return OSD_FileDiaog( shwnd, mode, title, filter, fullpath, path, ext );
}


////////////////////////////////////////////////////////////////
// bZ[W\
//
// :	mes			bZ[Wւ̃|C^
//			cap			EBhELvVւ̃|C^
//			type		\`w̃tO
// Ԓl:	int			ꂽ{^̎
//							OSDR_OK:     OK{^
//							OSDR_CANCEL: CANCEL{^
//							OSDR_YES:    YES{^
//							OSDR_NO:     NO{^
////////////////////////////////////////////////////////////////
int OSD_Message( const char *mes, const char *cap, int type )
{
	int Type = MB_OK;
	
	// bZ[W{bNX̃^Cv
	switch( type&0x000f ){
	case OSDM_OK:			Type = MB_OK;			break;
	case OSDM_OKCANCEL:		Type = MB_OKCANCEL;		break;
	case OSDM_YESNO:		Type = MB_YESNO;		break;
	case OSDM_YESNOCANCEL:	Type = MB_YESNOCANCEL;	break;
	}
	
	// bZ[W{bNX̃ACR^Cv
	switch( type&0x00f0 ){
	case OSDM_ICONERROR:	Type |= MB_ICONERROR;		break;
	case OSDM_ICONQUESTION:	Type |= MB_ICONQUESTION;	break;
	case OSDM_ICONWARNING:	Type |= MB_ICONWARNING;		break;
	case OSDM_ICONINFO:		Type |= MB_ICONINFORMATION;	break;
	}
	
	// eEBhE̓XN[T[tFXƌߑł
	SDL_SysWMinfo WinInfo;
	SDL_VERSION( &WinInfo.version );
	HWND hwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	
	int res = MessageBox( hwnd, mes, cap, Type | MB_TOPMOST );
	
	switch( res ){
	case IDOK:	return OSDR_OK;
	case IDYES:	return OSDR_YES;
	case IDNO:	return OSDR_NO;
	default:	return OSDR_CANCEL;
	}
}




////////////////////////////////////////////////////////////////
// F̖O擾
//
// :	num			FR[h
// Ԓl:	char *		F̖Oւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_ColorName( int num )
{
	static const char *JColorName[] = {
		" MODE1 Set1 "	,	" MODE1 Set1 ",		" MODE1 Set2 ",		" MODE1 Set2 IW",
		" MODE2 ",			" MODE2 ",			" MODE2 ",			" MODE2 ",
		" MODE2 ",			" MODE2 VA",		" MODE2 }[^",		" MODE2 IW",
		" MODE3 Set1 ",		" MODE3 Set1 ",		" MODE3 Set1 ",		" MODE3 Set1 ",
		" MODE3 Set2 ",		" MODE3 Set2 VA",	" MODE3 Set2 }[^",	" MODE3 Set2 IW",
		" MODE4 Set1 ",		" MODE4 Set1 ",		" MODE4 Set2 ",		" MODE4 Set2 ",
		" MODE4 Set1 ɂ "," MODE4 Set1 ɂ "," MODE4 Set1 ɂ -",	" MODE4 Set1 ɂ -",
		" MODE4 Set2 ɂ "," MODE4 Set2 ɂ "," MODE4 Set2 ɂ "," MODE4 Set2 ɂ ",
		" mk2` ()",		" mk2` ",			" mk2` ",			" mk2` ",
		" mk2` ",			" mk2` Ԏ",			" mk2` F",			" mk2` DF",
		" mk2` ",			" mk2` ",			" mk2` ",			" mk2` ",
		" mk2` ",			" mk2` }[^",		" mk2` VA",		" mk2` " };
	
	if( num < 0 || num >= (int)sizeof(JColorName) ) return NULL;
	else                                            return JColorName[num];
}


////////////////////////////////////////////////////////////////
// tHg쐬
//
// :	cx				(Sp)
//			cy				
// Ԓl:	SDL_Surface *	tHgT[tFXւ̃|C^
////////////////////////////////////////////////////////////////
SDL_Surface *OSD_MakeFont( int cx, int cy )
{
	int Wscr = cx * 95;
	int Hscr = cy * 97;	// ptHg2s܂
	
	// foCXReLXg擾
	HDC hBmpDC = CreateCompatibleDC( NULL );
	
	// tHg쐬
	HFONT NewFont = CreateFont( cy, cx/2,
//	HFONT NewFont = CreateFont( cy, cx/2*3/4,
								FW_DONTCARE, FW_DONTCARE, FW_REGULAR,
								FALSE, FALSE, FALSE,
								SHIFTJIS_CHARSET,
								OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
								DEFAULT_QUALITY,
								FF_MODERN | FIXED_PITCH, "" );
	HFONT OldFont = (HFONT)SelectObject( hBmpDC, NewFont );
	SetTextColor( hBmpDC, RGB(255,255,255) );
	SetBkColor(   hBmpDC, RGB(  0,  0,  0) );
	
	// Ɨprbg}bv쐬
	BYTE *ppixel;	// sNZf[^
	char bmbuf[sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*2];
	BITMAPINFO &bi        = *(BITMAPINFO *)&bmbuf;
	BITMAPINFOHEADER &bih = bi.bmiHeader;
	ZeroMemory( &bih, sizeof(bmbuf) );
	
	bi.bmiColors[1].rgbBlue     = 255;
	bi.bmiColors[1].rgbGreen    = 255;
	bi.bmiColors[1].rgbRed      = 255;
	bi.bmiColors[1].rgbReserved = 0;
	
	bih.biSize     = sizeof(BITMAPINFOHEADER);
	bih.biWidth    = Wscr;
	bih.biHeight   = -Hscr;
	bih.biPlanes   = 1;
	bih.biBitCount = 8;
	HBITMAP hBmp   = CreateDIBSection( NULL, (BITMAPINFO*)&bi, DIB_RGB_COLORS, (void **)&ppixel, 0, 0 );
	ZeroMemory( ppixel, Wscr * Hscr );
	
	SelectObject( hBmpDC, hBmp );
	SelectObject( hBmpDC, GetStockObject( BLACK_BRUSH ) );
	Rectangle( hBmpDC, 0, 0, Wscr, Hscr );
	
	// tHg`
	BYTE strk[2] = { 0x00, 0x00 };
	// p
	for( int y=0; y<2; y++ ){
		for( int x=32; x<128; x++ ){
			strk[0] = x + y * 128;
			TextOut( hBmpDC, x*cx/2, y*cy, (char *)strk, 1 );
		}
	}
	// Sp
	for( int y=1; y<95; y++ ){
		for( int x=1; x<95; x++ ){
			strk[0] = y + 0x20;
			strk[1] = x + 0x20;
			Jis2Sjis( &strk[0], &strk[1] );
			TextOut( hBmpDC, x*cx, (y+2)*cy, (char *)strk, 2 );
		}
	}
	
	SelectObject( hBmpDC, OldFont );
	
	SDL_Surface *SFont = SDL_CreateRGBSurface( SDL_SWSURFACE | SDL_SRCCOLORKEY, Wscr, Hscr, 8, 0, 0, 0, 0 );
	memcpy( (BYTE *)SFont->pixels, ppixel, Wscr*Hscr );
	SDL_SetColors( SFont, (SDL_Color *)bi.bmiColors, 0, 2 );
	
	
	DeleteObject( NewFont );
	DeleteObject( hBmp );
	DeleteDC( hBmpDC );
	
	return SFont;
}


BOOL OSD_CreateFont( char *hfile, char *zfile, int size )
{
	int Wscr = size * 96 * 2;
	int Hscr = size * 96 * 2;
	
	// foCXReLXg擾
	HDC hBmpDC = CreateCompatibleDC( NULL );
	
	// tHg쐬
	HFONT NewFont = CreateFont( size * 2, size,
								FW_DONTCARE, FW_DONTCARE, FW_REGULAR,
								FALSE, FALSE, FALSE,
								SHIFTJIS_CHARSET,
								OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
								DEFAULT_QUALITY,
								FF_MODERN | FIXED_PITCH, "" );
	HFONT OldFont = (HFONT)SelectObject( hBmpDC, NewFont );
	SetTextColor( hBmpDC, RGB(255,255,255) );
	SetBkColor(   hBmpDC, RGB(  0,  0,  0) );
	
	// Ɨprbg}bv쐬
	BYTE *ppixel;	// sNZf[^
	char bmbuf[sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*2];
	BITMAPINFO &bi        = *(BITMAPINFO *)&bmbuf;
	BITMAPINFOHEADER &bih = bi.bmiHeader;
	ZeroMemory( &bih, sizeof(bmbuf) );
	
	bi.bmiColors[1].rgbBlue     = 255;
	bi.bmiColors[1].rgbGreen    = 255;
	bi.bmiColors[1].rgbRed      = 255;
	bi.bmiColors[1].rgbReserved = 0;
	
	bih.biSize     = sizeof(BITMAPINFOHEADER);
	bih.biWidth    = Wscr;
	bih.biHeight   = -Hscr;
	bih.biPlanes   = 1;
	bih.biBitCount = 8;
	HBITMAP hBmp   = CreateDIBSection( NULL, (BITMAPINFO*)&bi, DIB_RGB_COLORS, (void **)&ppixel, 0, 0 );
	ZeroMemory( ppixel, Wscr * Hscr );
	
	SelectObject( hBmpDC, hBmp );
	SelectObject( hBmpDC, GetStockObject( BLACK_BRUSH ) );
	
	// tHg`
	BYTE strk[2] = { 0x00, 0x00 };
	// p
	if( hfile ){
		Rectangle( hBmpDC, 0, 0, Wscr, Hscr );
		for( int y=0; y<2; y++ ){
			for( int x=32; x<128; x++ ){
				strk[0] = x + y * 128;
				TextOut( hBmpDC, x*size, y*size*2, (char *)strk, 1 );
			}
		}
		SDL_Surface *FFont = SDL_CreateRGBSurface( SDL_SWSURFACE | SDL_SRCCOLORKEY, Wscr, size*2*2, 8, 0, 0, 0, 0 );
		memcpy( (BYTE *)FFont->pixels, ppixel, Wscr*size*2*2 );
		SDL_SetColors( FFont, (SDL_Color *)bi.bmiColors, 0, 2 );
		SavePNG( hfile, FFont );
		SDL_FreeSurface( FFont );
	}
	
	// Sp
	if( zfile ){
		Rectangle( hBmpDC, 0, 0, Wscr, Hscr );
		for( int y=1; y<95; y++ ){
			for( int x=1; x<95; x++ ){
				strk[0] = y + 0x20;
				strk[1] = x + 0x20;
				Jis2Sjis( &strk[0], &strk[1] );
				TextOut( hBmpDC, x*size*2, y*size*2, (char *)strk, 2 );
			}
		}
		SDL_Surface *FFont = SDL_CreateRGBSurface( SDL_SWSURFACE | SDL_SRCCOLORKEY, Wscr, Hscr, 8, 0, 0, 0, 0 );
		memcpy( (BYTE *)FFont->pixels, ppixel, Wscr*Hscr );
		SDL_SetColors( FFont, (SDL_Color *)bi.bmiColors, 0, 2 );
		SavePNG( zfile, FFont );
		SDL_FreeSurface( FFont );
	}
	
	SelectObject( hBmpDC, OldFont );
	DeleteObject( NewFont );
	DeleteObject( hBmp );
	DeleteDC( hBmpDC );
	
	return TRUE;
}
